/*
  Measures the latency of the whole FabArcade
*/

// Ports and variable for current state of output
const int out = 2;  //tbd
const int pr1 = A0;
int currentState = LOW;

//timeout for the measurement in µs
const unsigned long timeout = 1000000;

//variables for the different time points that are measured
unsigned long t0 = 0;
unsigned long t1 = 0;
//unsigned long t2 = 0;

void toggleOutput(){
  // switch the state of the output from high 
  // to low or vice versa
  if(currentState == LOW){
    currentState = HIGH;
  } else {
    currentState = LOW;
  }
  
  digitalWrite(out, currentState);
}

bool isLightOn(){
  // check if the light is on, which corresponds to
  // analog values well above around 450 or 500
  //Serial.println(analogRead(pr1));
  if(analogRead(pr1) < 500){
    return false;
  } else {
    return true;
  }
}

void setup() {
  // initialize out as output and in1 as input
  pinMode(out, OUTPUT);
  pinMode(pr1, INPUT);
  Serial.begin(9600);
}

void loop() {
  //toggleOutput(); 
  digitalWrite(out, LOW);
  t0 = micros();
  delay(1);
  digitalWrite(out, HIGH);
  t1 = micros();

  //check if the light is on yet or if it timed out
  while(!isLightOn() && t1-t0 < timeout){
    t1 = micros();
  }

  //return timeout if there was one or the time if there wasn't
  if(t1-t0 >= timeout){
    Serial.println("TIMEOUT");
  } 
  else {
    Serial.println(t1-t0);//-4000);
  }

  //toggleOutput();
  // a few ms to chill for good measure
  // this comment was brought to you by your local worker's union
  delay(200);
}
