use gilrs::{Gilrs, Button, Event};
use gilrs::EventType::ButtonReleased;

use std::time;

fn main() {
    let mut gilrs = Gilrs::new().unwrap();

    // Iterate over all connected gamepads
    for (_id, gamepad) in gilrs.gamepads() {
        println!("{} is {:?}", gamepad.name(), gamepad.power_info());
    }

    let mut active_gamepad = None;

    // Examine new events
    loop {
        let now = time::Instant::now();
        match gilrs.next_event() {
            Some(Event {id, event, time }) => {

                println!("{:?} {:?} new event from {}: {:?}", now.elapsed(), time, id, event);
                active_gamepad = Some(id);
                match event {
                    ButtonReleased(_, _) => {
                        //println!("{:?} New ButtonPress from {}", time, id);
                        //active_gamepad = Some(id);
                        std::process::exit(0x0100);
                    }
                    _ => ()
                }
            }
            _ => println!("{:?} None", now.elapsed())
        }
    }
}
