use std::fs;
use std::time;

use gilrs::{Gilrs, Event};
use gilrs::EventType::{ButtonPressed, AxisChanged};

fn main() {
    let gpio = "/sys/class/gpio/gpio4/value";

    let mut gilrs = Gilrs::new().unwrap();

    loop {
        let gpiostate = fs::read_to_string(gpio).expect(":(");
        if gpiostate.contains("0") {
            let now = time::Instant::now();

            loop {
                match gilrs.next_event() {
                    Some(Event{ event, ..}) => {
                        if let ButtonPressed(_, _) = event {
                            println!("{:?}", now.elapsed());
                            break;
                        }
                    }
                    _ => ()
                }
            }
        }
    }
}
